#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# RtmCompData.py             Created on: 2004/11/02
#                            Author    : Tsuyoshi Tanabe
"""
    GUIѥǥʥδ饹
"""
#
# ǥʥǴΤϡfullpathФ륪֥ȥե󥹤Τߤѹ
#

# dictionary format
# {'name-service name':{'fullpath':obj-ref}}



import sys,os
import string
import mutex
from omniORB import CORBA
#import RtmParser as rtxml

# RTM importϡPYTHONPATHIDL֤Τǥ쥯ȥɲä
from RTM import *

NAME_PATH_NUM = 5


#----------------------------------------------------------------------
class RtmDictCore:
    """ǥʥ饹"""
    def __init__(self, parent):
        """饹ν

        []
        parent -- ƥ饹

        []
        void
        """
        self.parent = parent
        self.dict = {}
        self.default_ns = 'localhost'
        self.cur_ns = self.default_ns
        default_dict = {}
        self.dict[self.default_ns] = {}

    def __del__(self):
        pass
#        for cur_ns in  self.dict.keys():
#            for pos_keys in  self.dict[cur_ns].keys():
#                try:
#                    ref = self.dict[cur_ns][pos_keys]
#                    ref._release(ref)
#                except:
#                    print '__del__: obj-ref release error!'


    def SplitTokenToFullpath(self, fullname):
        """եѥ̾ΤΥȡʬ

        []
        fullname -- '/'ڤΥեѥ
                    ذʾʸϥ顼

        []
        key_list -- ȡlist
        """
        key_list = string.splitfields(fullname,'/')
        if len(key_list) > NAME_PATH_NUM:
            print "Error: SplitTokenToFullpath: fullpath is too long(please set to 5 or less)"
            key_list = None
        return key_list


    def ClearDictionary(self):
        """ǥʥκ

        []
        void

        []
        void 
        """
        self.dict[self.cur_ns] = None

    def GetInPortToRefCallback(self, fullpath):
        """ǥʥΥ֥ȥե󥹤InPort

        []
        fullpath     -- եѥ

        []
        inport_list  -- ݡȥꥹ
        """
#        print "                     , ref :",ref
        self.retlist = []
        try:
            ref = self.dict[self.cur_ns][fullpath]['objref']
            ref = ref._narrow(RTCBase)

            in_list = []
            ret_list = []
            in_list = ref._get_inports()
            tmp = {}
            n = 0
            for inp in in_list:
                inp = inp._narrow(InPort)
                tmp = {}
                tmp['ref'] = inp
                prof = inp._get_profile()
                tmp['name'] = prof.name
                tmp['port_type'] = prof.port_type.name()

#                tmp['name'] = "in:test-dummy" + '%d'% n
#                tmp['name'] = "in" + '%d'% n
#                tmp['port_type'] = "RTM::TimedFloat:test-dummy"
#                tmp['port_type'] = "RTM::TimedFloat"
                ret_list.append(tmp)
                n=n+1
        except:
            print 'error! GetObjRefToInPort() '
            ret_list = []

        self.retlist = ret_list
        return ret_list

    def GetOutPortToRefCallback(self, fullpath):
        """ǥʥΥ֥ȥե󥹤OutPort

        []
        fullpath  -- եѥ

        []
        outport_list -- ȥݡȥꥹ
        """
        self.retlist = []
        try:
            ref = self.dict[self.cur_ns][fullpath]['objref']
            ref = ref._narrow(RTCBase)

            out_list = []
            out_list = ref._get_outports()
            ret_list = []
            tmp = {}
            n=0
            for outp in out_list:
                outp = outp._narrow(OutPort)
                tmp = {}
                tmp['ref'] = outp
                prof = outp._get_profile()
                tmp['name'] = prof.name
                tmp['port_type'] = prof.port_type.name()

#                tmp['name'] = "out:test-dummy" + '%d'% n
#                tmp['port_type'] = "TimedFloat:test-dummy"
                ret_list.append(tmp)
                n=n+1
        except:
            print 'error! GetObjRefToOutPort() '
            ret_list = []

        self.retlist = ret_list
        return ret_list


    def SetObjRefToFullpath(self, position, comp):
        """ǥʥ˥֥ȥե󥹤ɲ

        []
        position -- եѥ
        comp      -- objref,id,kind Υǥʥ

        []
        void
        """
        ref = comp['objref']
        if comp['kind'] == 'rtc':
            if not self.dict[self.cur_ns].has_key(position):
#                print 'check duplicate !!:',comp['objref']
                try:
                    ref = ref._duplicate(ref)
                except:
                    print 'duplicate exception!!:',comp['objref']
            try:
                ref = ref._narrow(RTCBase)
            except:
                print 'SetObjRefToFullPath: narrow error!'
                ref = None

        self.dict[self.cur_ns][position] = {}
        self.dict[self.cur_ns][position]['objref'] = ref
        self.dict[self.cur_ns][position]['id'] = comp['id']
        self.dict[self.cur_ns][position]['kind'] = comp['kind']
        self.dict[self.cur_ns][position]['bname'] = comp['bname']


    def GetObjRefToFullpathCallback(self, position):
        """ǥʥ꤫饪֥ȥե󥹤

        []
        position -- եѥ

        []
        ref      -- ֥ȥե
        """

        self.ret = None
        if self.dict[self.cur_ns].has_key(position):
            ref = self.dict[self.cur_ns][position]['objref']
        else:
            print "Error: GetObjRefToFullpath: fullpath error!"
            ref = None

        self.ret = ref
        return ref

    def GetKindToFullpathCallback(self, position):
        """ǥʥ꤫Kind

        []
        position -- եѥ

        []
        kind      -- Kind
        """
        kind_list = ['ns','host_cxt','mgr_cxt','mgr','cate_cxt','mod_cxt','rtc']

        self.ret = None
        if position.find('NS:') != -1:
            kind = 'ns'
        elif self.dict[self.cur_ns].has_key(position):
            kind = self.dict[self.cur_ns][position]['kind']
        else:
            print "Error: GetKindToFullpath: fullpath error!"
            kind = 'unknown'

        if kind not in kind_list:
            kind = 'unknown'

        self.ret = kind
        return kind

    def GetIdToFullpathCallback(self, position):
        """ǥʥ꤫Id

        []
        position -- եѥ

        []
        Id      -- Id
        """

        self.ret = None
        if self.dict[self.cur_ns].has_key(position):
            Id = self.dict[self.cur_ns][position]['id']
        else:
            print "Error: GetIdToFullpath: fullpath error!"
            Id = None

        self.ret = Id
        return Id

    def GetBindingNameToFullpath(self, position):
        """ǥʥ꤫Binding_name

        []
        position -- եѥ

        []
        bname      -- binding name
        """

        self.ret = None
        if self.dict[self.cur_ns].has_key(position):
            bname = self.dict[self.cur_ns][position]['bname']
        else:
            print "Error: GetBindingNameToFullpath: fullpath error!"
            bname = None

        self.ret = bname
        return bname


#----------------------------------------------------------------------
class RtmCompData(RtmDictCore):
    """ǥʥΥ饹ʥåѡ
    ˡǥʥѤåѡ᥽åɤ򵭽Ҥ
    """
    def __init__(self, parent):
        """饹ν


        []
        parent -- ƥ饹

        []
        void
        """
        RtmDictCore.__init__(self,parent)
        self.parent = parent
        self.Mutex = mutex.mutex()

    def GetCompStateCallback(self,fullpath):
        self.ret2 = 0
        tmp = 0
        try:
            ref = self.GetObjRefToFullpathCallback(fullpath)
            ref = ref._narrow(RTCBase)
        except :
            print 'GetCompState: obj-ref error:',fullpath
            tmp = 0
            self.ret2 = 0
            return
        try:
            tmp_port = ref._get_rtc_state()
            tmp_port = tmp_port._narrow(OutPort)
            tmp = tmp_port.get()
            tmp = tmp.value()
            tmp = tmp.data
            print "refresh state:",tmp
        except :
            print 'GetCompState: rtc_state error:',fullpath
#            tmp = RTComponent.RTC_ERROR
            tmp = 0

        self.ret2 = tmp
        return tmp

    def GetCompState(self,fullpath):
        self.Mutex.lock(self.GetCompStateCallback,fullpath)
        self.Mutex.unlock()
        return self.ret2

    def GetCompNameCallback(self,fullpath):
        self.ret2 = ''
        key_list = self.SplitTokenToFullpath(fullpath)
        num = len(key_list)

        self.ret2 = key_list[num-1]
        return key_list[num-1]

    def GetCompName(self,fullpath):
        self.Mutex.lock(self.GetCompNameCallback,fullpath)
        self.Mutex.unlock()
        return self.ret2

    def GetObjRefToFullpath(self, position):
        self.Mutex.lock(self.GetObjRefToFullpathCallback,position)
        self.Mutex.unlock()
        return self.ret

    def GetInPortToRef(self, fullpath):
        self.Mutex.lock(self.GetInPortToRefCallback,fullpath)
        self.Mutex.unlock()
        return self.retlist

    def GetOutPortToRef(self, fullpath):
        self.Mutex.lock(self.GetOutPortToRefCallback,fullpath)
        self.Mutex.unlock()
        return self.retlist

    def TreeListCompStartCallback(self,fullpath):
        """TreeListΥݡͥȤ򥹥
        SystemDrawѤΥ᥽åɤѹ礹ǽ

        []
        fullpath -- եѥ

        []
        void
        """
        self.ret2 = RTM_OK
        ret = RTM_OK
        ref = self.GetObjRefToFullpathCallback(fullpath)
        try:
            ret = ref.rtc_start()
            if ret != RTM_OK:
                print "Error rtc_start(): ",fullpath
        except:
            print "ExceptError rtc_start(): ",fullpath
            ret = RTM_ERR

        # ٤ƤSystemDraw̤ݡͥȤοѹ
        # parent:RtdFrame , drawWin:MDIҥɥ(RtdSystemDraw)
        for sys_no in self.parent.drawWin.keys():
            self.parent.drawWin[sys_no].changeCompColor(fullpath, 'active')
#            self.parent.drawWin[sys_no].changeCompColor(fullpath)

        self.ret2 = ret
        return ret

    def TreeListCompStart(self,fullpath):
        self.Mutex.lock(self.TreeListCompStartCallback,fullpath)
        self.Mutex.unlock()
        return self.ret2

    def TreeListCompStopCallback(self,fullpath):
        """TreeListΥݡͥȤ򥹥ȥå
        SystemDrawѤΥ᥽åɤѹ礹ǽ

        []
        fullpath -- եѥ

        []
        void
        """
        self.ret2 = RTM_OK
        ret = RTM_OK
        ref = self.GetObjRefToFullpathCallback(fullpath)
        try:
            ret = ref.rtc_stop()
            if ret != RTM_OK:
                print "Error rtc_stop(): ",fullpath
        except:
            print "ExceptError rtc_stop(): ",fullpath
            ret = RTM_ERR

        for sys_no in self.parent.drawWin.keys():
            self.parent.drawWin[sys_no].changeCompColor(fullpath, 'inactive')
#            self.parent.drawWin[sys_no].changeCompColor(fullpath)
        self.ret2 = ret
        return ret

    def TreeListCompStop(self,fullpath):
        self.Mutex.lock(self.TreeListCompStopCallback,fullpath)
        self.Mutex.unlock()
        return self.ret2

    def TreeListCompResetCallback(self,fullpath):
        """TreeListΥݡͥȤꥻå
        SystemDrawѤΥ᥽åɤѹ礹ǽ

        []
        fullpath -- եѥ

        []
        void
        """
        self.ret2 = RTM_OK
        ret = RTM_OK
        ref = self.GetObjRefToFullpathCallback(fullpath)
        try:
            ret = ref.rtc_reset()
            if ret != RTM_OK:
                print "Error rtc_reset(): ",fullpath
        except:
            print "ExceptError rtc_reset(): ",fullpath
            ret = RTM_ERR

        for sys_no in self.parent.drawWin.keys():
            self.parent.drawWin[sys_no].changeCompColor(fullpath, 'inactive')
#            self.parent.drawWin[sys_no].changeCompColor(fullpath)

        self.ret2 = ret
        return ret

    def TreeListCompReset(self,fullpath):
        self.Mutex.lock(self.TreeListCompResetCallback,fullpath)
        self.Mutex.unlock()
        return self.ret2

    def TreeListCompExitCallback(self,fullpath):
        """TreeListΥݡͥȤExit
        SystemDrawѤΥ᥽åɤѹ礹ǽ

        []
        fullpath -- եѥ

        []
        void
        """
        self.ret2 = RTM_OK
        ret = RTM_OK
        ref = self.GetObjRefToFullpathCallback(fullpath)
        try:
            ret = ref.rtc_exit()
            if ret != RTM_OK:
                print "Error rtc_exit(): ",fullpath
        except:
            print "ExceptError rtc_exit(): ",fullpath
            ret = RTM_ERR

        for sys_no in self.parent.drawWin.keys():
            self.parent.drawWin[sys_no].changeCompColor(fullpath, 'inactive')
#            self.parent.drawWin[sys_no].changeCompColor(fullpath)

        self.ret2 = ret
        return ret

    def TreeListCompExit(self,fullpath):
        self.Mutex.lock(self.TreeListCompExitCallback,fullpath)
        self.Mutex.unlock()
        return self.ret2

    def TreeListCompKillCallback(self,fullpath):
        """TreeListΥݡͥȤkill
        SystemDrawѤΥ᥽åɤѹ礹ǽ

        []
        fullpath -- եѥ

        []
        void
        """
        self.ret2 = RTM_OK
        ret = RTM_OK
        ref = self.GetObjRefToFullpathCallback(fullpath)
        try:
            ret = ref.rtc_kill()
            if ret != RTM_OK:
                print "Error rtc_kill(): ",fullpath
        except:
            print "Error rtc_kill(): ",fullpath
            ret = RTM_ERR

        for sys_no in self.parent.drawWin.keys():
            self.parent.drawWin[sys_no].changeCompColor(fullpath, 'inactive')
#            self.parent.drawWin[sys_no].changeCompColor(fullpath)

        self.ret2 = ret
        return ret

    def TreeListCompKill(self,fullpath):
        self.Mutex.lock(self.TreeListCompKillCallback,fullpath)
        self.Mutex.unlock()
        return self.ret2

    def GetIdToFullpath(self,fullpath):
        self.Mutex.lock(self.GetIdToFullpathCallback,fullpath)
        self.Mutex.unlock()
        return self.ret

    def GetKindToFullpath(self,fullpath):
        self.Mutex.lock(self.GetKindToFullpathCallback,fullpath)
        self.Mutex.unlock()
        return self.ret

    def setCompBodyColor(self,fullpath, state):
        for sys_no in self.parent.drawWin.keys():
            self.parent.drawWin[sys_no].changeCompColor(fullpath,state)
